player = require 'player'

local _TurnCount = 0

local M = class(player, function(self)
	player.init(self) -- must init base!
    self.name = "Eyes White"

      self.R = 50
      self.G = 200
      self.B = 0
end)

-- data[1][1] = X
-- data[1][2] = Y
-- data[1][3] = bodyRotation
-- data[1][4] = turretRotation
-- data[1][5] = hitPoints
-- data[1][6] = turretX
-- data[1][7] = turretY
function M:process(data)
    -- do all calculations and setting of desired actions here
	_TurnCount = _TurnCount + 1
	if (_TurnCount % 4) == 0 then
		local turn = love.math.random(-1, 1)
		self.bodyRotationDelta = .1 * ((turn == 0) and 0 or 1)
		self.turretDelta = 0
	else
		self.bodyRotationDelta = 0
		self.turretDelta = .1
	end
	self.bodySpeed = love.math.random(4, 5)
	-- Find the closest enemy tank
	-- First make a list of live enemy tanks
	local tankList = {}
	for iter = 2, #data, 1 do
		if data[iter][1] == true then
			table.insert(tankList, data[iter])
		end
	end
	-- Then find the closest
	local closestTank = {}
	local closestTankDistance = 10000
	for iter = 1, #tankList, 1 do
		local tempDistance = distance(data[1][1], data[1][2], tankList[iter][2], tankList[iter][3])
		if tempDistance < closestTankDistance then
			closestTank = tankList[iter]
			closestTankDistance = tempDistance
		end
	end
	-- Slew the gun to the closest tank
	local gunAngle = getRadian(data[1][6], data[1][7], closestTank[2], closestTank[3])
	if gunAngle > data[1][4] then
		if data[1][4] > 0 and data[1][4] < .5 * math.pi and gunAngle > 1.5 * math.pi and gunAngle < 2 * math.pi then
			if 2 * math.pi - gunAngle + data[1][4] >= .1 then
				self.turretDelta = -.1
			else
				self.turretDelta = -2 * math.pi - gunAngle + data[1][4]
			end
		
		elseif gunAngle - data[1][4] > .1 then
			self.turretDelta = .1
		else
			self.turretDelta = gunAngle - data[1][4]
		end
	elseif gunAngle < data[1][4] then
		if data[1][4] > 1.5 * math.pi and data[1][4] < 2 * math.pi and gunAngle > 0 and gunAngle < .5 * math.pi then
			if 2 * math.pi - data[1][4] + gunAngle >= .1 then
				self.turretDelta = .1
			else
				self.turretDelta = 2 * math.pi - data[1][4] + gunAngle
			end
		elseif data[1][4] - gunAngle > .1 then
			self.turretDelta = -.1
		else
			self.turretDelta = -1 * (data[1][4] - gunAngle)
		end
	else
		self.turretDelta = 0
	end
	-- Only shoot if target close to gun angle
	if math.abs(gunAngle - data[1][4]) <= 0.01 then
		self.shouldFire = true
	else
		self.shouldFire = false
	end
end

return M
