require 'class'

_BodyR = 0
_BodyG = 0
_BodyB = 0

local M=class(function(self, x, y, playerCode, hitPoints)
	-- FIELDS
    self.X = x
    self.Y = y
    self.playerCode = playerCode
    self.hitPoints = hitPoints
    self.turretRotation = 0
	self.bodyRotation = love.math.random() * 6.28
    self.firingLimitCount = 0
--    self.turretoffsetX = 0
--    self.turretoffsetY = 0
	self.height = 28
	self.width = 16
	self.size = self.height - ((self.height - self.width) / 2)
	self.wasHit = false
	self.turnKilled = 0
	self.name = playerCode.name
	
	-- Set body color
	-- Is the player chosen color too light?
	if playerCode.R + playerCode.G + playerCode.B > 690 then
		-- Yes
		_BodyR = playerCode.R - 25
		_BodyG = playerCode.G - 25
		_BodyB = playerCode.B - 25
	else
		-- No
		_BodyR = playerCode.R
		_BodyG = playerCode.G
		_BodyB = playerCode.B
	end
	
	-- Is the tank starting in the top half of the arena?
    if (y < love.graphics.getHeight() / 2) then
        --  Yes, point the turret down
        self.turretRotation = 3.14
    end

    self.turretMesh = love.graphics.newMesh(buildTurretVertices(255), nil, "strip")
    self.tankMesh = love.graphics.newMesh(buildTankVertices(255), nil, "strip")
end)

-- OPERATIONS
function M:draw()
	if self.hitPoints == .5 then
		self.turretMesh = love.graphics.newMesh(buildTurretVertices(63), nil, "strip")
		self.tankMesh = love.graphics.newMesh(buildTankVertices(63), nil, "strip")
	end
	-- tank
    love.graphics.draw(self.tankMesh, self.X, self.Y, self.bodyRotation, 1, 1, self.width / 2, self.height / 2)
	-- turret
    love.graphics.draw(self.turretMesh, self.X + (-5 * math.sin(self.bodyRotation)), self.Y + (5 * math.cos(self.bodyRotation)), self.turretRotation, 1, 1, 8, 18)
	-- name
    love.graphics.setColor(0, 0, 0, 255)
	if self.Y > love.graphics.getHeight() - 20 then
		if self.X <= 15 then
			love.graphics.printf(self.playerCode.name, self.X, self.Y - 30, 100, "center")
		elseif self.X >= love.graphics.getWidth() - 15 then
			love.graphics.printf(self.playerCode.name, self.X - 100, self.Y - 30, 100, "center")
		else
			love.graphics.printf(self.playerCode.name, self.X - 50, self.Y - 30, 100, "center")
		end
	else
		if self.X <= 15 then
			love.graphics.printf(self.name, self.X, self.Y + 15, 100, "center")
		elseif self.X >= love.graphics.getWidth() - 15 then
			love.graphics.printf(self.name, self.X - 100, self.Y + 15, 100, "center")
		else
			love.graphics.printf(self.name, self.X - 50, self.Y + 15, 100, "center")
		end
	end
end

function M:fire()
	-- Is the player firing
    if self.playerCode.shouldFire then
		-- Yes
		-- Validate timing limit
        if self.firingLimitCount > 120 then
            self.firingLimitCount = 0
            return true
        else
            self.firingLimitCount = self.firingLimitCount + 1
            return false
        end
	else
		-- No
		-- Count a turn
		self.firingLimitCount = self.firingLimitCount + 1
    end
end

-- LOGIC
function buildTankVertices(alpha)
	return {
        {
            0, 0,
            0, 0,
            _BodyR, _BodyG, _BodyB, alpha
        },
        {
            16, 0,
            0, 0,
            _BodyR, _BodyG, _BodyB, alpha
        },
        {
            16, 28,
            0, 0,
            _BodyR, _BodyG, _BodyB, alpha
        },
        {
            0, 28,
            0, 0,
            _BodyR, _BodyG, _BodyB, alpha
        },
        {
            0, 0,
            0, 0, 
            _BodyR, _BodyG, _BodyB, alpha
        },
    }
end

function buildTurretVertices(alpha)
	return {
        {
            9, 4,
            0, 0,
            0, 0, 0, alpha
        },
        {
            7, 4,
            0, 0,
            0, 0, 0, alpha
        },
        {
            9, 14,
            0, 0,
            0, 0, 0, alpha
        },
        {
            7, 14,
            0, 0,
            0, 0, 0, alpha
        },
        {
            13, 14,
            0, 0,
            100, 100, 100, alpha
        },
        {
            13, 22,
            0, 0,
            100, 100, 100, alpha
        },
        {
            8, 24,
            0, 0,
            100, 100, 100, alpha
        },
        {
            3, 22,
            0, 0,
            100, 100, 100, alpha
        },
        {
            3, 14,
            0, 0,
            100, 100, 100, alpha
        },
        {
            13, 14,
            0, 0,
            100, 100, 100, alpha
        },
        {
            13, 22,
            0, 0,
            100, 100, 100, alpha
        },
        {
            3, 22,
            0, 0,
            100, 100, 100, alpha
        },
    }
end

return M
